require "alparser/version"

require "forwardable"
require "httparty"
require "nokogiri"

class Alparser
  extend Forwardable

  autoload :Parser,     "alparser/parser"
  autoload :Climb,      "alparser/climb"
  autoload :User,       "alparser/climb"

  autoload :Branc,      "alparser/branc"
  autoload :Plezanje,   "alparser/plezanje"

  attr_reader :url
  attr_accessor :parser

  def initialize url, parser: Alparser::Branc
    @url = url
    @parser = parser.new(@url)
  end

  def_delegators :@parser, \
    :club_climbs, :all_club_climbs, \
    :number_of_pages

  LIST = [
    { url: "http://www.kozjak.org",  parser: Alparser::Branc },
    { url: "http://www.pdtam.org",   parser: Alparser::Branc },
    { url: "http://www.aocelje.org", parser: Alparser::Branc },
    { url: "http://ao.pdgrmada.org", parser: Alparser::Branc },
    { url: "http://alphut.net",      parser: Alparser::Branc },
    { url: "http://plezanje.net",    parser: Alparser::Plezanje }
  ]

end
