module Alparser::Keyed

  module InstanceMethods

    # Key is build from domain, date, class and id if foreign key if present
    def f_id sep="-"
      [domain, self.date.to_s, self.class.to_s.split("::").last, self.id]
        .compact
        .join("|")
        .downcase
        .gsub!(/[^a-z0-9\-_]+/, sep)
    end

    private

    def domain
      host = URI.parse(self.base_uri).host.downcase
      host.start_with?('www.') ? host[4..-1] : host
    end
  end

  def self.included(receiver)
    receiver.send :include, InstanceMethods
  end
end

class Alparser::Climb < OpenStruct
  include Alparser::Keyed
end

class Alparser::User < OpenStruct
  include Alparser::Keyed
end
