module Alparser::Parser

  class HtmlParser < HTTParty::Parser
    SupportedFormats.merge!('text/html' => :html)

    def html
      doc = Nokogiri::HTML(body)
      doc.encoding = 'utf-8'
      doc
    end
  end

  module ClassMethods

  end

  module InstanceMethods
    attr_accessor :number_of_pages
    attr_accessor :url

    def initialize url
      self.class.base_uri(@url = url)
    end

  end

  def self.included(receiver)
    receiver.extend         ClassMethods
    receiver.send :include, HTTParty
    receiver.send :include, InstanceMethods
    receiver.send :parser,  HtmlParser
  end
end
