class Alparser::Plezanje
  include Alparser::Parser

  def club_climbs
    raise "not implemented"
  end

  def all_club_climbs n: 1000
    handle_page self.class.get("/climbing/public/showPubClimbs.asp", query: {
      n: n,
      o: "AI",
      t: "y"
    })
  end

  private

  def handle_page response
    response.parsed_response["pubClimbs"].to_a.map! do |key, item|
      item.map { |sub_item| climb_from(sub_item) }
    end.flatten!
  end

  # READ: http://www.plezanje.net/climbing/public/showPubClimbs.asp?t=y&n=1000&o=AI
  def climb_from item
    climb = Alparser::Climb.new(item)
    climb.date = Date.parse(item["date"])
    climb.route = item["route"] || item["icefall"]
    climb.mountain_range = item["craig"] || item["valley"]
    climb.user = Alparser::User.new(id: nil, name: item["name"], base_uri: @url)
    climb.user_name = item["name"]
    climb.country = nil
    climb.country_id = nil
    climb.user_id = nil
    climb.has_notes = false
    climb.has_images = false
    climb.grade = item["diff"]
    climb.kind = item["ascent"]
    climb.conditions = nil # item[""]

    climb.base_uri = @url

    climb
  end

end
